/****************************************************************************
ipwops.cpp
Wed 4/04/2007 12:41 pm  creation from ogops.cpp.

****************************************************************************/
#include "ipw.h"
#include "tla.h"

/****************************************************************************
****************************************************************************/
_f char *versionoid(void) {
  static char *v;

  if (v)
  return v;

  string s = (string)sTLA + " " + __DATE__, d;

  string::iterator i;
  char lastchar=0;

  for (i = s.begin(); i!=s.end(); ++i) {
    if (
    (*i==' ') &&
    (lastchar==' ')
    )
    continue;   //throw away annoying double spaces.

    lastchar = *i;
    d.push_back(tolower(*i));

  }

  return v=strdup(d.c_str());

}


/****************************************************************************
_copy

typedef struct {

  bool debug;

  bool dont_ascii;  //MUST be set if we are not to save ascii version.
  bool dont_ascii_encrypt;  //set to save encrypted as binary.

  string password,
  dataname,
  asciiname;

#if DONT_QUIT
  bool dont_quit;
#endif

  JSTRINGLIST *clips;

  string selection;
  bool dont_select;

} OPTIONS;

_uncopy

If I made tree_file a string, I couldn't initialize Goptions statically; it
produces a cryptic error message to say so. Ain't it wunnerful?

****************************************************************************/


#define DEFPASSWORD  "you take tomorrow gimme today"

/****************************************************************************
_copy
struct dirt {
  private:
  bool is_dirty;
  public:
  void changedData(void);
  void clean(void);
  bool dirty(void);
};
_uncopy
****************************************************************************/

_v dirt dirty;

void dirt::changedData(void) {
  is_dirty = true;
}

void dirt::clean(void) {
  is_dirty = false;
}

bool dirt::dirty(void) {
  return is_dirty;
}



#if 0

static bool dirtydata; //, dirty_password;

//_f void changedPassword(void) {
//  dirty_password = true;
//}

void changedData(void) {
  dirtydata = true;
}

bool dirty(void) {
  return
//  dirty_password ||
  dirtydata;
}

void clean(void) {
//  dirty_password =
  dirtydata = false;
}
#endif

/****************************************************************************
****************************************************************************/


_v OPTIONS Goptions;
//can't init with string.

_v bool Gneed_password;
static string Gpassword;
/****************************************************************************
this contains the clear-text password whenever the program is running, so bad
men in your memory can steal it.
****************************************************************************/

/****************************************************************************
_copy
void setGpassword(const string &s, bool beDirty = true);
_uncopy
****************************************************************************/

void setGpassword(const string &s, bool beDirty) {
  Gpassword = decontrol(s);
  if (Gpassword=="")
  Gpassword = DEFPASSWORD;
  Goptions.password = encrypt_string(Gpassword);
  Gneed_password = false;

  if (beDirty) {
//    changedPassword(); //because we changed the global password.
    dirty.changedData();    //because presumably that means we have to re-encode.
  }
}

_f bool chkGpassword(const string &s) {
  return
  encrypt_string(decontrol(s)) == Goptions.password;
}

static char *ininame;

#define MAINSEC "options"
#define CLIPSEC "clips"

_f void setininame(char *who) {
  ininame = who;
}

_f char *getininame(void) {
  return ininame;
}

_f void getdata(void) {
  if (Goptions.debug)
  printf("getdata()\n");
  if (!Gneed_password) {
    file_decrypt_list(Gpassword.c_str(),Goptions.dataname.c_str());
    if (Gthelist.size() < 1) {
      Gthelist.push_back(*examplejpw());  //no records, make one up.
      dirty.changedData();                      //because it is.
    }
    else {
      sortthelist();                  //else sort them.
      dirty.clean();                  //because we just read it.
    }
  }
  if (Goptions.debug)
  printf("Gthelist.size(): %d\n",Gthelist.size());
}

static void putdata(void) {
//  if ( dirtydata ) {

    if (Goptions.debug)
    printf("putdata()\n");

    list_encrypt_file(Gpassword.c_str(),Goptions.dataname.c_str());

    if (!Goptions.dont_ascii) {
      list_encrypt_file(Gpassword.c_str(),Goptions.asciiname.c_str(), false);
    }

//    dirtydata = false;
//  }
}

static void defoptions(void) {
//set some handy defaults.
//  Goptions.dataname = re_ext(ininame,".e");
//  Goptions.asciiname = re_ext(ininame,".txt");
/****************************************************************************
Tue 6/05/2007 11:19 am. See I outsmarted myself. I wanted the ini file to be a
txt file for EZ-editing in the friendly mac, so I named it ipw_ini.txt. But
then I re-used the ininame root for the acsiiname and all-in-all it was
bad....
****************************************************************************/

  Goptions.dataname = ipwinidir() + ipwrut() + ".e";
  Goptions.asciiname = ipwinidir() + ipwrut() + ".txt";

}

_v string ini_at;   //this is here so I can print in a debug statement.

_f void getoptions(void) {
  if (!ininame) {
    ininame = strdup(def_ininame().c_str());
  }

  defoptions();

//force file creation at first-time usage. Shouldn't hurt anything.
  if (!exist(ininame)) {
//    changedPassword();
    dirty.changedData();
  }

  jIni ini(ininame);
//the ini is freed automatically at exit of getoptions.

  atexit(finishoptions);

  Goptions.debug =
  ini.readbool(MAINSEC,"debug",Goptions.debug);
  //which main may have been set already.

  //Goptions.debug = true;
/****************************************************************************
Fri 8/17/2007 7:07 pm. In the CLI upw version, (1.) VS2005 routinely
misreports the value of globals, which sadly includes Goptions, (2.) I have
super-ingenious scheme of multiple redirection for option file which confuses
me horribly, and so I'm always reading the wrong file. AND I can't tell
because the witless VS2005 debugger says Goptions.debug is true.... Note that
I already set debug to true in upw.cpp so I can see printfs before getoptions.
****************************************************************************/

  if (Goptions.debug)
  printf(
  "iniat:   %s\n"
  "ininame: %s\n"
  ,ini_at.c_str()
  ,ininame
  );

  if (Goptions.debug)
  printf("getoptions()\n");

  Goptions.dont_ascii =
  ini.readbool(MAINSEC,"dont_ascii",Goptions.dont_ascii);

  Goptions.dont_ascii_encrypt =
  ini.readbool(MAINSEC,"dont_ascii_encrypt",Goptions.dont_ascii_encrypt);

#if DONT_QUIT
  Goptions.dont_quit =
  ini.readbool(MAINSEC,"dont_quit",Goptions.dont_quit);
#endif

  Goptions.dataname =
  j_path(
  ini.readstr(MAINSEC,"dataname",Goptions.dataname.c_str())
  );

  Goptions.asciiname =
  j_path(
  ini.readstr(MAINSEC,"asciiname",Goptions.asciiname.c_str())
  );

  if (Goptions.debug) {
    printf(
    "dataname: %s\n"
    "asciiname: %s\n",
    Goptions.dataname.c_str(),Goptions.asciiname.c_str());
  }

  Goptions.password = encrypt_string(DEFPASSWORD);

  Goptions.password =
  ini.readstr(MAINSEC,"password",Goptions.password.c_str());

  Goptions.selection =
  ini.readstr(MAINSEC,"selection",Goptions.selection.c_str());

  Goptions.dont_select =
  ini.readbool(MAINSEC,"dont_select",Goptions.dont_select);

  if (Goptions.password == encrypt_string(DEFPASSWORD)) {
    setGpassword(DEFPASSWORD,false);
  }
  else
  Gneed_password = true;

  Goptions.clips = ini.readlist(CLIPSEC);

//someone else'll have to getdata().

}

_f void putoptions(void) {

  if (Goptions.debug)
  printf("putoptions()\n");

//  if (dirty_password)

//always write options. I wanted to write a utility thing, so I might as well
//write them all.
  if (!ininame) {
    ininame = strdup(def_ininame().c_str());
  }

//set some handy defaults.
  jIni ini(ininame);

  ini.writebool(MAINSEC,"debug",Goptions.debug);
  //which main may have set already.

  ini.writebool(MAINSEC,"dont_ascii",Goptions.dont_ascii);

  ini.writebool(MAINSEC,"dont_ascii_encrypt",Goptions.dont_ascii_encrypt);

  ini.writestr(MAINSEC,"dataname",Goptions.dataname);

  ini.writestr(MAINSEC,"asciiname",Goptions.asciiname);

//  Goptions.password = encrypt_string(Gpassword);
//  should use setGpassword().

//check global password situation.
//  if (dirty_password)
  if (dirty.dirty())
  ini.writestr(MAINSEC,"password",Goptions.password.c_str());

  ini.writestr(MAINSEC,"version",versionoid());
  //leave harmless note.

  if (Gthelist.size()>0)
  ini.writestr(MAINSEC,"selection",Gthelist[Gtheindex].title);

  ini.writebool(MAINSEC,"dont_select",Goptions.dont_select);

  ini.writelist(CLIPSEC,Goptions.clips);

  ini.writeini();   //write the data.


//  }

  if (dirty.dirty()) {
    putdata();
    dirty.clean();
  }

}

_f void finishoptions(void) {
  putoptions();
  jIni::freelist(&Goptions.clips);
}

/****************************************************************************
Fri 5/11/2007 4:10 pm. This used to be in the command-line main, but it or
something like it is needed in the GUI versions
****************************************************************************/

#if j_MAC
#define DOT_DIR_PW "~/.jgo_ipw"   //unix invisible mystery dir name.
#define DOC_DIR "~/Documents"

_f char *nix_dir(void) {
  static char *p;
  string dotdir;

  if (p)
  return p;

  dotdir = j_path(DOT_DIR_PW);

  if (isdir(dotdir.c_str()))
  return p=DOT_DIR_PW;
  //if dotdir exists then use that. User would've made it....

  if (isdir(j_path(DOC_DIR).c_str()))
  return p=DOC_DIR;
  //else if docdir exists, use that; really preferable, likely to get
  //backed-up. And of course Macintosh. ... And lookee there, Linux might have
  //one!

  //OK neither, so we'll try and make the dot directory.
  if (!mkdir(dotdir.c_str(),0)) {
    if (Goptions.debug)
    printf("Made '%s' dir\n",DOT_DIR_PW);
    return p=DOT_DIR_PW;
  }

  //nothing worked. Use naked home directory.

  return p="~";   //'jes the home I guess.
}
#endif

//returns the program root, i.e. ipw, ipw_cmd, a whatever....
_f string ipwrut(void) {
  static string rut;

  if (rut!="")
  return rut;

  return
  rut = re_ext(jlast_path(__Jargv[0]).c_str(),"");

}

//return the directory of the ininame. Shouldn't be called until ininame is
//set.
_f string ipwinidir(void) {
  static string ini_dir;

  if (ini_dir!="")
  return ini_dir;

  string front,last;

  jsplit_path(ininame,front,last);

  return
  ini_dir = jslash(front);

}

#define INIAT "ini_at.txt"
_f string def_ininame(void) {
  static string fn;

  if (fn!="")
  return fn;


#if j_WIN
  if ((fn=jgetenv("APPDATA"))=="")
  fn = "c:\\MY DOCUMENTS";
#endif

#if j_MAC
  fn = j_path(nix_dir());
#endif

/****************************************************************************
the theory is might be a little redirection in ~/.ini_at.txt. ... First, if
there's one in the executable directory -- i.e., INSIDE the mac application --
use that. Because that's stupidly the way I started this nonsense. // warn't
so stupid; comes in ril handy.... And anyway, let's use it for the default in
all cases.
****************************************************************************/
  string front, last;

//ok let's locate the executable directory from tradtional argv[0] pgm name.
  jsplit_path(__Jargv[0],front,last);

//First, provide the escape hatch ini_at.txt in the exec dir.
  ini_at = (jslash(front) + INIAT).c_str();

  if (!exist(ini_at.c_str())) {
//if the exe path ini_at doesn't exist.
#if j_MAC
    ini_at = j_path(((string)"~" + Gslashs + "." INIAT));
#endif

#if j_WIN
    ini_at = j_path(fn + Gslashs + INIAT);
#endif

  }

/****************************************************************************
Now after all that, we get the actual location of the ini file. The default of
which is PROGRAM_ROOT_NAME + "_ini.txt".
****************************************************************************/

  jIni i(ini_at.c_str());

  fn =
  j_path(
  i.readstr(MAINSEC,"inifile",(jslash(fn)+ipwrut() + "_ini.txt").c_str())
  );

//now write the result to ini_at file.
  i.writestr(MAINSEC,"inifile",fn);
  i.writeini();

  return fn;

}



