/****************************************************************************
jini.h
Fri 1/26/2007 2:40 pm   creation.
Tue 5/01/2007 11:09 am  added read() q.v.
Mon 5/14/2007 12:43 pm  miscellany.
Wed 5/30/2007 10:22 am  Included string *and* string.h! Better safe than
sorry....
Fri 6/15/2007 5:08 pm   Added readlist et al.

****************************************************************************/
#ifndef _JINI_H
#define _JINI_H

/****************************************************************************
****************************************************************************/
#include "managed.h"

/****************************************************************************
****************************************************************************/

//#include <iostream>
#include <fstream>
#include <list>
#include <map>
#include <string>   // OUTSIDE stupid namespace. Apparently.

#ifdef _MSC_VER
  #define strdup _strdup
//  #define _CRT_SECURE_jNO_WARNINGS (1) //stop silly warnings.
//OK that didn't work; let's try.
  #pragma warning( disable : 4996 )

#endif

#include "jini_sbrs.h"

/****************************************************************************
****************************************************************************/
namespace jIni_space {
/****************************************************************************
****************************************************************************/

typedef std::list<std::string> JSTRINGLIST;

typedef struct {
  char *s;
  int v;
} mapval;

typedef std::map<std::string, mapval> INIMAP;
typedef std::pair<std::string,mapval> PAIRMAP;
/****************************************************************************
Wed 1/31/2007 1:46 pm. If I put it *inside* the class, apparently it can't be
used as a private class return type! ?
****************************************************************************/

class jIni {
  public:
  jIni(const char *name);     //reads the init file.
  jIni(void);                 //you have to read it. So it can be global
                              //without reading.
  ~jIni(void);

  void read(const char *name);     //changes name, reads it.

  void changename(const char *name);
  //handy for test and other things.

  int readint(const char *sec, const char *key, int def);
  std::string readstr(const char *sec, const char *key, const char *def);

//which it will probably allocate; use free to get rid of.
  char *readc_str(const char *sec, const char *key, const char *def);

  bool readbool(const char *sec, const char *key, bool def);

  INIMAP *readsec(const char *sec);
  void writesec(const char *sec, INIMAP *m);
  static void freesec(INIMAP **map);

//so it gets an unsorted list, see?
  JSTRINGLIST *readlist(const char *sec);
  void writelist(const char *sec, JSTRINGLIST *list);
  static void freelist(JSTRINGLIST **list);

  void writeint(const char *sec, const char *key, int val);
  void writestr(const char *sec, const char *key, std::string val);
  void writebool(const char *sec, const char *key, bool val);

  void writeini(void);
  //writes it with any changes. DOESN'T happen automatically.

  private:
  std::string filename;
//  std::list<std::string> lines;
  JSTRINGLIST lines;

  void read_file(void);
  void write_file(void);

  JSTRINGLIST::iterator find_section(const char *key);

  std::string find_value(const char *section, const char *key);

  JSTRINGLIST::iterator find_value_it(const char *section, const char *key);

};

/****************************************************************************
****************************************************************************/
} //namespace jIni_space.

/****************************************************************************
****************************************************************************/

#endif    //#ifdef _JINI_H
